
/** @mainpage %VOS API Documentation

    Welcome to the %VOS library. This API documentation contains fairly complete
    information about the C++ classes that make up the core %VOS library, as well
    as various MetaObjects, Auxilliary and Utility libraries.

    Please send feedback on this documentation so we can make it as clear and
    complete as possible. Email Reed <reed@interreality.org> or Pete
    <tetron@interreality.org> or send  a message to
    <a href="http://interreality.org/lists">the discussion list</a>.

    All of the classes are listed in the <a href="annotated.html">annotated class
    index</a>, the <a href="classes.html">full alphabetical listing</a>,
    and in the <a href="hierarchy.html">class hierarchy</a>. The <a
    href="modules.html">modules listing</a> groups classes by library.

    See the %VOS website <a href="http://www.interreality.org">interreality.org</a>
    for up to date news, docs and code.

    <h3>%VOS core library</h3>

    Some of the more important classes you should take a look at are VOS::vRef, 
     VOS::Vobject,
    VOS::MetaObject, VOS::Site, VOS::LocalVipSiteExtension, VOS::Log,
    VOS::ParentChildRelation, and VOS::ChildChangeListener, from the @ref libvos
    library.
    
    <h3>Metaobject libraries</h3>

    For working with properties, see VOS::Property and VOS::PropertyListener and 
    @ref libmetaobject_property.

    For 3D objects, see the A3DL namespace in the @ref libmetaobject_a3dl library. 

    Also of interest are Avatar, Talkative,  Search, Hypercard,  
    and Metadata from the @ref libmetaobject_misc library.

    For the service discovery metaobject, see VOS::Services from the
    @ref libmetaobject_services library.

    For object versioning, see VOS::VersionedVobject in the @ref 
    libmetaobject_versioned library and  VOS::RevisionControlPersistance in 
    the @ref libvosext_revcontrol extension library.

    <h3>Extension libraries</h3>

    Use VOS::HTTPServer in @ref libvosext_http for
    accessing Vobjects through HTTP,  VOS::SQLPersistance (abstract interface) in
    @ref libvosext_sqlpersist and @ref libvosext_mysqldb (which provides 
    an implementation for mySQL)
    for saving object information in a database
    backend, and VOS::FileSystemPersistance in @ref libvosext_fspersist for
    saving object information as files.  Use VOS::RevisionControlPersistence 
    in libvosext_revcontrol to enable object revision control.
    
    
    <h3>Auxilliary libraries</h3>

    For the type helpers library (@ref libtypehelper), see the TypeHelper class.
    For the ASE library (@ref libASE), see libASE.h

    <h3>Application utility libraries</h3>

    A useful class for making %VOS based applications is VOSApp and
    its subclass VOSDaemon (for background services), in the @ref libvosapp
    library.

*/

/** @defgroup libvos libvos 
    VOS Library.
    required libraries: @LIBSSL@ @LIBSOCKS@ @LIBZ@ @LEXLIB@
*/
/** @defgroup libmetaobject_property libmetaobject_property 
    Property metaobject.
    Required libraries: -lvos
*/
/** @defgroup libmetaobject_misc libmetaobject_misc 
    Misc metaobjects.
    Required libraries: -lvos -lmetaobject_property
*/
/** @defgroup libmetaobject_services libmetaobject_services 
    Service list metaobject.
    Libraries: -lvos -lmetaobject_property -lmetaobject_misc 
        @RENDEZVOUS_LFLAGS@
*/
/** @defgroup libmetaobject_a3dl libmetaobject_a3dl 
    3D metaobjects.
    Libraries: -lvos -lmetaobject_property
*/
/** @defgroup libvosapp libvosapp 
    Daemon utility library.
    Libraries: -lvos -lmetaobject_property -lmetaobject_misc -lmetaobject_services
*/
/** @defgroup libASE libASE 
    ASE (3D Studio Max ASCII Scene Export) library.
*/
/* Xdefgroup libmetatronic libmetatronic
    Implements VOSGUI interfaces by providing a layer between libmetaobject_gui
    and wxWidgets (see <a href="http://www.wxwidgets.org">www.wxwidgets.org</a>).
    To get started with metatronic, see the Metatronic class.

    Libraries: <code>-lvos -lmetaobject_property -lmetaboject_gui</code>.  
    For wxWidgets flags, use <code>`wx-config --lflags`</code> for link flags
    and <code>`wx-config --cxxflags`</code> for compiler flags.
*/

/** @defgroup libmetaobject_versioned libmetaobject_versioned
    Provides MetaObject interface to object versions.
    @sa libvosext_revcontrol

    Libraries: <code>-lvos -lmetaobject_property</code>
*/

/** @defgroup libvosext_revcontrol libvosext_revcontrol
    Provides extensions that record changes made to Vobjects on a site.
    @see libmetaobject_versioned

    Libraries: <code>-lvos -lmetaobject_property</code>
*/

/** @defgroup libvosext_http libvosext_http
    Provides extensions that allow access to Vobjects and Properties via HTTP.

    Libraries: <code>-lvos -lmetaobject_property</code>
*/

/** @defgroup libvosext_sqlpersist libvosext_sqlpersist
    Provides extensions that use an SQL database as a persistent Vobject
    backend.
    @see libvosext_mysqldb

    Libraries: <code>-lvos</code>
*/

/** @defgroup libvosext_mysqldb libvosext_mysqldb
    Provides access to mySQL for the SQL persistance extension.
    @see libvosext_sqlpersist
    
    Libraries: <code>@LIBMYSQLCLIENT@</code>
*/

/** @defgroup libvosext_fspersist libvosext_fspersist
    Provides extensions that use files on the filesystem as a persistent
    Vobject backend.

    Libraries: <code>-lvos</code>
*/





